Index: /palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3866)
@@ -725,313 +746,313 @@
 ! Section 1: Define initialization and boundary grids
 !------------------------------------------------------------------------------
-       CALL init_grid_definition('palm', grid=palm_grid,                       &
-               xmin=0.0_dp, xmax=lx,                                           &
-               ymin=0.0_dp, ymax=ly,                                           &
-               x0=x0, y0=y0, z0=z0,                                            &
-               nx=nx, ny=ny, nz=nz, z=z, zw=zw, ic_mode=cfg % ic_mode)
-
-!
-!--    Subtracting 1 because arrays will be allocated with nlon + 1 elements.
-       CALL init_grid_definition('cosmo-de', grid=cosmo_grid,                  &
-               xmin=lonmin_cosmo, xmax=lonmax_cosmo,                           &
-               ymin=latmin_cosmo, ymax=latmax_cosmo,                           &
-               x0=x0, y0=y0, z0=0.0_dp,                                        &
-               nx=nlon-1, ny=nlat-1, nz=nlev-1)
-
-!
-!--    Define intermediate grid. This is the same as palm_grid except with a
-!--    much coarser vertical grid. The vertical levels are interpolated in each
-!--    PALM column from COSMO's secondary levels. The main levels are then
-!--    computed as the averages of the bounding secondary levels.
-       CALL init_grid_definition('palm intermediate', grid=palm_intermediate,  &
-               xmin=0.0_dp, xmax=lx,                                           &
-               ymin=0.0_dp, ymax=ly,                                           &
-               x0=x0, y0=y0, z0=z0,                                            &
-               nx=nx, ny=ny, nz=nlev-2)
-
-       CALL init_grid_definition('boundary', grid=u_initial_grid,              &
+    CALL init_grid_definition('palm', grid=palm_grid,                       &
+            xmin=0.0_wp, xmax=lx,                                           &
+            ymin=0.0_wp, ymax=ly,                                           &
+            x0=x0, y0=y0, z0=z0,                                            &
+            nx=nx, ny=ny, nz=nz, z=z, zw=zw, ic_mode=cfg%ic_mode)
+
+!
+!-- Subtracting 1 because arrays will be allocated with nlon + 1 elements.
+    CALL init_grid_definition('cosmo-de', grid=cosmo_grid,                  &
+            xmin=lonmin_cosmo, xmax=lonmax_cosmo,                           &
+            ymin=latmin_cosmo, ymax=latmax_cosmo,                           &
+            x0=x0, y0=y0, z0=0.0_wp,                                        &
+            nx=nlon-1, ny=nlat-1, nz=nlev-1)
+
+!
+!-- Define intermediate grid. This is the same as palm_grid except with a
+!-- much coarser vertical grid. The vertical levels are interpolated in each
+!-- PALM column from COSMO's secondary levels. The main levels are then
+!-- computed as the averages of the bounding secondary levels.
+    CALL init_grid_definition('palm intermediate', grid=palm_intermediate,  &
+            xmin=0.0_wp, xmax=lx,                                           &
+            ymin=0.0_wp, ymax=ly,                                           &
+            x0=x0, y0=y0, z0=z0,                                            &
+            nx=nx, ny=ny, nz=nlev-2)
+
+    CALL init_grid_definition('boundary', grid=u_initial_grid,              &
+            xmin = dx, xmax = lx - dx,                                      &
+            ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+            x0=x0, y0=y0, z0 = z0,                                          &
+            nx = nx-1, ny = ny, nz = nz,                                    &
+            z=z, ic_mode=cfg%ic_mode)
+
+    CALL init_grid_definition('boundary', grid=v_initial_grid,              &
+            xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+            ymin = dy, ymax = ly - dy,                                      &
+            x0=x0, y0=y0, z0 = z0,                                          &
+            nx = nx, ny = ny-1, nz = nz,                                    &
+            z=z, ic_mode=cfg%ic_mode)
+
+    CALL init_grid_definition('boundary', grid=w_initial_grid,              &
+            xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+            ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+            x0=x0, y0=y0, z0 = z0,                                          &
+            nx = nx, ny = ny, nz = nz-1,                                    &
+            z=zw, ic_mode=cfg%ic_mode)
+
+    CALL init_grid_definition('boundary intermediate', grid=u_initial_intermediate,      &
+            xmin = dx, xmax = lx - dx,                                      &
+            ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+            x0=x0, y0=y0, z0 = z0,                                          &
+            nx = nx-1, ny = ny, nz = nlev - 2)
+
+    CALL init_grid_definition('boundary intermediate', grid=v_initial_intermediate,      &
+            xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+            ymin = dy, ymax = ly - dy,                                      &
+            x0=x0, y0=y0, z0 = z0,                                          &
+            nx = nx, ny = ny-1, nz = nlev - 2)
+
+    CALL init_grid_definition('boundary intermediate', grid=w_initial_intermediate,      &
+            xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+            ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+            x0=x0, y0=y0, z0 = z0,                                          &
+            nx = nx, ny = ny, nz = nlev - 1)
+
+    IF (boundary_variables_required)  THEN
+!
+!------------------------------------------------------------------------------
+! Section 2: Define PALM-4U boundary grids
+!------------------------------------------------------------------------------
+       CALL init_grid_definition('boundary', grid=scalars_east_grid,           &
+               xmin = lx + 0.5_wp * dx, xmax = lx + 0.5_wp * dx,               &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=scalars_west_grid,           &
+               xmin = -0.5_wp * dx, xmax = -0.5_wp * dx,                       &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=scalars_north_grid,          &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = ly + 0.5_wp * dy, ymax = ly + 0.5_wp * dy,               &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=scalars_south_grid,          &
+               xmin =  0.5_wp * dx, xmax = lx - 0.5_wp * dx,                   &
+               ymin = -0.5_wp * dy, ymax = -0.5_wp * dy,                       &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=scalars_top_grid,            &
+               xmin =  0.5_wp * dx, xmax = lx - 0.5_wp * dx,                   &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = ny, nz = 1, z=(/z_top/))
+
+       CALL init_grid_definition('boundary', grid=u_east_grid,                 &
+               xmin = lx, xmax = lx,                                           &
+               ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=u_west_grid,                 &
+               xmin = 0.0_wp, xmax = 0.0_wp,                                   &
+               ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=u_north_grid,                &
                xmin = dx, xmax = lx - dx,                                      &
-               ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
+               ymin = ly + 0.5_wp * dy, ymax = ly + 0.5_wp * dy,               &
                x0=x0, y0=y0, z0 = z0,                                          &
-               nx = nx-1, ny = ny, nz = nz,                                    &
-               z=z, ic_mode=cfg % ic_mode)
-
-       CALL init_grid_definition('boundary', grid=v_initial_grid,              &
-               xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
+               nx = nx-1, ny = 0, nz = nz, z=z)
+    
+       CALL init_grid_definition('boundary', grid=u_south_grid,                &
+               xmin = dx, xmax = lx - dx,                                      &
+               ymin = -0.5_wp * dy, ymax = -0.5_wp * dy,                       &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx-1, ny = 0, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=u_top_grid,                  &
+               xmin = dx, xmax = lx - dx,                                      &
+               ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx-1, ny = ny, nz = 1, z=(/z_top/))
+
+       CALL init_grid_definition('boundary', grid=v_east_grid,                 &
+               xmin = lx + 0.5_wp * dx, xmax = lx + 0.5_wp * dx,               &
                ymin = dy, ymax = ly - dy,                                      &
                x0=x0, y0=y0, z0 = z0,                                          &
-               nx = nx, ny = ny-1, nz = nz,                                    &
-               z=z, ic_mode=cfg % ic_mode)
-
-       CALL init_grid_definition('boundary', grid=w_initial_grid,              &
-               xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-               ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
+               nx = 0, ny = ny-1, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=v_west_grid,                 &
+               xmin = -0.5_wp * dx, xmax = -0.5_wp * dx,                       &
+               ymin = dy, ymax = ly - dy,                                      &
                x0=x0, y0=y0, z0 = z0,                                          &
-               nx = nx, ny = ny, nz = nz-1,                                    &
-               z=zw, ic_mode=cfg % ic_mode)
-
-       CALL init_grid_definition('boundary intermediate', grid=u_initial_intermediate,      &
+               nx = 0, ny = ny-1, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=v_north_grid,                &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = ly, ymax = ly,                                           &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=v_south_grid,                &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = 0.0_wp, ymax = 0.0_wp,                                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nz, z=z)
+
+       CALL init_grid_definition('boundary', grid=v_top_grid,                  &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = dy, ymax = ly - dy,                                      &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = ny-1, nz = 1, z=(/z_top/))
+
+       CALL init_grid_definition('boundary', grid=w_east_grid,                 &
+               xmin = lx + 0.5_wp * dx, xmax = lx + 0.5_wp * dx,               &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nz - 1, z=zw)
+
+       CALL init_grid_definition('boundary', grid=w_west_grid,                 &
+               xmin = -0.5_wp * dx, xmax = -0.5_wp * dx,                       &
+               ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nz - 1, z=zw)
+
+       CALL init_grid_definition('boundary', grid=w_north_grid,                &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = ly + 0.5_wp * dy, ymax = ly + 0.5_wp * dy,               &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nz - 1, z=zw)
+
+       CALL init_grid_definition('boundary', grid=w_south_grid,                &
+               xmin =  0.5_wp * dx, xmax = lx - 0.5_wp * dx,                   &
+               ymin = -0.5_wp * dy, ymax = -0.5_wp * dy,                       &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nz - 1, z=zw)
+
+       CALL init_grid_definition('boundary', grid=w_top_grid,                  &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = ny, nz = 1, z=(/zw_top/))
+
+       CALL init_grid_definition('boundary intermediate', grid=scalars_east_intermediate,   &
+               xmin = lx + 0.5_wp * dx, xmax = lx + 0.5_wp * dx,               &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=scalars_west_intermediate,   &
+               xmin = -0.5_wp * dx, xmax = -0.5_wp * dx,                       &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=scalars_north_intermediate,  &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = ly + 0.5_wp * dy, ymax = ly + 0.5_wp * dy,               &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=scalars_south_intermediate,  &
+               xmin =  0.5_wp * dx, xmax = lx - 0.5_wp * dx,                   &
+               ymin = -0.5_wp * dy, ymax = -0.5_wp * dy,                       &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=scalars_top_intermediate,    &
+               xmin =  0.5_wp * dx, xmax = lx - 0.5_wp * dx,                   &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = ny, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=u_east_intermediate,         &
+               xmin = lx, xmax = lx,                                           &
+               ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=u_west_intermediate,         &
+               xmin = 0.0_wp, xmax = 0.0_wp,                                   &
+               ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=u_north_intermediate,        &
                xmin = dx, xmax = lx - dx,                                      &
-               ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
+               ymin = ly + 0.5_wp * dy, ymax = ly + 0.5_wp * dy,               &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx-1, ny = 0, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=u_south_intermediate,        &
+               xmin = dx, xmax = lx - dx,                                      &
+               ymin = -0.5_wp * dy, ymax = -0.5_wp * dy,                       &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx-1, ny = 0, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=u_top_intermediate,          &
+               xmin = dx, xmax = lx - dx,                                      &
+               ymin = 0.5_wp * dy, ymax = ly - 0.5_wp * dy,                    &
                x0=x0, y0=y0, z0 = z0,                                          &
                nx = nx-1, ny = ny, nz = nlev - 2)
 
-       CALL init_grid_definition('boundary intermediate', grid=v_initial_intermediate,      &
-               xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
+       CALL init_grid_definition('boundary intermediate', grid=v_east_intermediate,         &
+               xmin = lx + 0.5_wp * dx, xmax = lx + 0.5_wp * dx,               &
+               ymin = dy, ymax = ly - dy,                                      &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny-1, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=v_west_intermediate,         &
+               xmin = -0.5_wp * dx, xmax = -0.5_wp * dx,                       &
+               ymin = dy, ymax = ly - dy,                                      &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny-1, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=v_north_intermediate,        &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = ly, ymax = ly,                                           &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=v_south_intermediate,        &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = 0.0_wp, ymax = 0.0_wp,                                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nlev - 2)
+
+       CALL init_grid_definition('boundary intermediate', grid=v_top_intermediate,          &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
                ymin = dy, ymax = ly - dy,                                      &
                x0=x0, y0=y0, z0 = z0,                                          &
                nx = nx, ny = ny-1, nz = nlev - 2)
 
-       CALL init_grid_definition('boundary intermediate', grid=w_initial_intermediate,      &
-               xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-               ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
+       CALL init_grid_definition('boundary intermediate', grid=w_east_intermediate,         &
+               xmin = lx + 0.5_wp * dx, xmax = lx + 0.5_wp * dx,               &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nlev - 1)
+
+       CALL init_grid_definition('boundary intermediate', grid=w_west_intermediate,         &
+               xmin = -0.5_wp * dx, xmax = -0.5_wp * dx,                       &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = 0, ny = ny, nz = nlev - 1)
+
+       CALL init_grid_definition('boundary intermediate', grid=w_north_intermediate,        &
+               xmin = 0.5_wp * dx, xmax = lx - 0.5_wp * dx,                    &
+               ymin = ly + 0.5_wp * dy, ymax = ly + 0.5_wp * dy,               &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nlev - 1)
+
+       CALL init_grid_definition('boundary intermediate', grid=w_south_intermediate,        &
+               xmin =  0.5_wp * dx, xmax = lx - 0.5_wp * dx,                   &
+               ymin = -0.5_wp * dy, ymax = -0.5_wp * dy,                       &
+               x0=x0, y0=y0, z0 = z0,                                          &
+               nx = nx, ny = 0, nz = nlev - 1)
+
+       CALL init_grid_definition('boundary intermediate', grid=w_top_intermediate,          &
+               xmin =  0.5_wp * dx, xmax = lx - 0.5_wp * dx,                   &
+               ymin =  0.5_wp * dy, ymax = ly - 0.5_wp * dy,                   &
                x0=x0, y0=y0, z0 = z0,                                          &
                nx = nx, ny = ny, nz = nlev - 1)
-
-      IF (boundary_variables_required)  THEN
-!
-!------------------------------------------------------------------------------
-! Section 2: Define PALM-4U boundary grids
-!------------------------------------------------------------------------------
-          CALL init_grid_definition('boundary', grid=scalars_east_grid,           &
-                  xmin = lx + 0.5_dp * dx, xmax = lx + 0.5_dp * dx,               &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=scalars_west_grid,           &
-                  xmin = -0.5_dp * dx, xmax = -0.5_dp * dx,                       &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=scalars_north_grid,          &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = ly + 0.5_dp * dy, ymax = ly + 0.5_dp * dy,               &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=scalars_south_grid,          &
-                  xmin =  0.5_dp * dx, xmax = lx - 0.5_dp * dx,                   &
-                  ymin = -0.5_dp * dy, ymax = -0.5_dp * dy,                       &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=scalars_top_grid,            &
-                  xmin =  0.5_dp * dx, xmax = lx - 0.5_dp * dx,                   &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = ny, nz = 1, z=(/z_top/))
-
-          CALL init_grid_definition('boundary', grid=u_east_grid,                 &
-                  xmin = lx, xmax = lx,                                           &
-                  ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=u_west_grid,                 &
-                  xmin = 0.0_dp, xmax = 0.0_dp,                                   &
-                  ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=u_north_grid,                &
-                  xmin = dx, xmax = lx - dx,                                      &
-                  ymin = ly + 0.5_dp * dy, ymax = ly + 0.5_dp * dy,               &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx-1, ny = 0, nz = nz, z=z)
-    
-          CALL init_grid_definition('boundary', grid=u_south_grid,                &
-                  xmin = dx, xmax = lx - dx,                                      &
-                  ymin = -0.5_dp * dy, ymax = -0.5_dp * dy,                       &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx-1, ny = 0, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=u_top_grid,                  &
-                  xmin = dx, xmax = lx - dx,                                      &
-                  ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx-1, ny = ny, nz = 1, z=(/z_top/))
-
-          CALL init_grid_definition('boundary', grid=v_east_grid,                 &
-                  xmin = lx + 0.5_dp * dx, xmax = lx + 0.5_dp * dx,               &
-                  ymin = dy, ymax = ly - dy,                                      &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny-1, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=v_west_grid,                 &
-                  xmin = -0.5_dp * dx, xmax = -0.5_dp * dx,                       &
-                  ymin = dy, ymax = ly - dy,                                      &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny-1, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=v_north_grid,                &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = ly, ymax = ly,                                           &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=v_south_grid,                &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = 0.0_dp, ymax = 0.0_dp,                                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nz, z=z)
-
-          CALL init_grid_definition('boundary', grid=v_top_grid,                  &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = dy, ymax = ly - dy,                                      &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = ny-1, nz = 1, z=(/z_top/))
-
-          CALL init_grid_definition('boundary', grid=w_east_grid,                 &
-                  xmin = lx + 0.5_dp * dx, xmax = lx + 0.5_dp * dx,               &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nz - 1, z=zw)
-
-          CALL init_grid_definition('boundary', grid=w_west_grid,                 &
-                  xmin = -0.5_dp * dx, xmax = -0.5_dp * dx,                       &
-                  ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nz - 1, z=zw)
-
-          CALL init_grid_definition('boundary', grid=w_north_grid,                &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = ly + 0.5_dp * dy, ymax = ly + 0.5_dp * dy,               &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nz - 1, z=zw)
-
-          CALL init_grid_definition('boundary', grid=w_south_grid,                &
-                  xmin =  0.5_dp * dx, xmax = lx - 0.5_dp * dx,                   &
-                  ymin = -0.5_dp * dy, ymax = -0.5_dp * dy,                       &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nz - 1, z=zw)
-
-          CALL init_grid_definition('boundary', grid=w_top_grid,                  &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = ny, nz = 1, z=(/zw_top/))
-
-          CALL init_grid_definition('boundary intermediate', grid=scalars_east_intermediate,   &
-                  xmin = lx + 0.5_dp * dx, xmax = lx + 0.5_dp * dx,               &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=scalars_west_intermediate,   &
-                  xmin = -0.5_dp * dx, xmax = -0.5_dp * dx,                       &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=scalars_north_intermediate,  &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = ly + 0.5_dp * dy, ymax = ly + 0.5_dp * dy,               &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=scalars_south_intermediate,  &
-                  xmin =  0.5_dp * dx, xmax = lx - 0.5_dp * dx,                   &
-                  ymin = -0.5_dp * dy, ymax = -0.5_dp * dy,                       &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=scalars_top_intermediate,    &
-                  xmin =  0.5_dp * dx, xmax = lx - 0.5_dp * dx,                   &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = ny, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=u_east_intermediate,         &
-                  xmin = lx, xmax = lx,                                           &
-                  ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=u_west_intermediate,         &
-                  xmin = 0.0_dp, xmax = 0.0_dp,                                   &
-                  ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=u_north_intermediate,        &
-                  xmin = dx, xmax = lx - dx,                                      &
-                  ymin = ly + 0.5_dp * dy, ymax = ly + 0.5_dp * dy,               &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx-1, ny = 0, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=u_south_intermediate,        &
-                  xmin = dx, xmax = lx - dx,                                      &
-                  ymin = -0.5_dp * dy, ymax = -0.5_dp * dy,                       &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx-1, ny = 0, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=u_top_intermediate,          &
-                  xmin = dx, xmax = lx - dx,                                      &
-                  ymin = 0.5_dp * dy, ymax = ly - 0.5_dp * dy,                    &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx-1, ny = ny, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=v_east_intermediate,         &
-                  xmin = lx + 0.5_dp * dx, xmax = lx + 0.5_dp * dx,               &
-                  ymin = dy, ymax = ly - dy,                                      &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny-1, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=v_west_intermediate,         &
-                  xmin = -0.5_dp * dx, xmax = -0.5_dp * dx,                       &
-                  ymin = dy, ymax = ly - dy,                                      &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny-1, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=v_north_intermediate,        &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = ly, ymax = ly,                                           &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=v_south_intermediate,        &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = 0.0_dp, ymax = 0.0_dp,                                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=v_top_intermediate,          &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = dy, ymax = ly - dy,                                      &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = ny-1, nz = nlev - 2)
-
-          CALL init_grid_definition('boundary intermediate', grid=w_east_intermediate,         &
-                  xmin = lx + 0.5_dp * dx, xmax = lx + 0.5_dp * dx,               &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nlev - 1)
-
-          CALL init_grid_definition('boundary intermediate', grid=w_west_intermediate,         &
-                  xmin = -0.5_dp * dx, xmax = -0.5_dp * dx,                       &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = 0, ny = ny, nz = nlev - 1)
-
-          CALL init_grid_definition('boundary intermediate', grid=w_north_intermediate,        &
-                  xmin = 0.5_dp * dx, xmax = lx - 0.5_dp * dx,                    &
-                  ymin = ly + 0.5_dp * dy, ymax = ly + 0.5_dp * dy,               &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nlev - 1)
-
-          CALL init_grid_definition('boundary intermediate', grid=w_south_intermediate,        &
-                  xmin =  0.5_dp * dx, xmax = lx - 0.5_dp * dx,                   &
-                  ymin = -0.5_dp * dy, ymax = -0.5_dp * dy,                       &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = 0, nz = nlev - 1)
-
-          CALL init_grid_definition('boundary intermediate', grid=w_top_intermediate,          &
-                  xmin =  0.5_dp * dx, xmax = lx - 0.5_dp * dx,                   &
-                  ymin =  0.5_dp * dy, ymax = ly - 0.5_dp * dy,                   &
-                  x0=x0, y0=y0, z0 = z0,                                          &
-                  nx = nx, ny = ny, nz = nlev - 1)
-       ENDIF
+    ENDIF
 
 !                                                                              
